<?php
/** 
 * @author Sadad Developer
 * @package SADADQA
 * @copyright (C) 2020 - Sadad Developer
 * @license GNU/GPLv2 http://www.gnu.org/licenses/gpl-2.0.html  
 */
// Check to ensure this file is included in Joomla!
defined ( '_JEXEC' ) or die ( 'Direct Access to this location is not allowed.' );

/**
 * Class plugin
 *
 * @package SADADQA
 * @since 1.0
 */ 
if (!class_exists('vmPSPlugin'))
require(VMPATH_PLUGINLIBS . DS . 'vmpsplugin.php');

class plgVmPaymentSadadqa extends vmPSPlugin {

    public static $_this = false;

    function __construct(& $subject, $config) {

        parent::__construct($subject, $config);

        $this->_loggable = true;
        $this->tableFields = array_keys($this->getTableSQLFields());
        $this->_tablepkey = 'id';
        $this->_tableId = 'id';

        $varsToPush = array(
            'sadadqa_id' => array('', 'char'),
            'sadadqa_secret' => array('', 'char'),
            'payment_logos' => array('', 'char'),
            'sadadqa_lang' => array('', 'char'),
			'sadadqa_website' => array('', 'char'),
			'sadadqa_hide_loader' => array('', 'char'),
			'sadadqa_checkout_type' => array('', 'char'),
			'sadadqa_checkout_type2' => array('', 'char'),
            'status_pending' => array('', 'char'),
            'status_success' => array('', 'char'),
            'status_canceled' => array('', 'char')
        );
		$this->addVarsToPushCore($varsToPush, 1);
        $this->setConfigParameterable($this->_configTableFieldName, $varsToPush);

    }

    function _getSadadqaDetails($method)
    {
        $sadadqaDetails = array(
            'sadadqa_id' => $method->sadadqa_id,
            'sadadqa_secret' => $method->sadadqa_secret,
			'sadadqa_lang' => $method->sadadqa_lang,
			'sadadqa_website' => $method->sadadqa_website,
			'sadadqa_hide_loader' => $method->sadadqa_hide_loader,
			'sadadqa_checkout_type' => $method->sadadqa_checkout_type,
			'sadadqa_checkout_type2' => $method->sadadqa_checkout_type2
        );

        return $sadadqaDetails;
    }

    public function getVmPluginCreateTableSQL() {

        return $this->createTableSQL('Payment Sadadqa Table');
    }

    function getTableSQLFields() {

        $SQLfields = array(
            'id' => 'int(11) unsigned NOT NULL AUTO_INCREMENT ',
            'virtuemart_order_id' => 'int(11) UNSIGNED',
            'order_number' => 'char(32)',
            'virtuemart_paymentmethod_id' => 'mediumint(1) UNSIGNED',
            'payment_name' => 'char(255) NOT NULL DEFAULT \'\' ',
            'payment_order_total' => 'decimal(15,5) NOT NULL DEFAULT \'0.00000\' ',
            'payment_currency' => 'char(3) ',
            'sadadqa_transaction_id' => 'char(255) '
        );
        return $SQLfields;
    }

    function plgVmConfirmedOrder($cart, $order) {

        if (!($method = $this->getVmPluginMethod($order['details']['BT']->virtuemart_paymentmethod_id))) {
            return null; // Another method was selected, do nothing
        }
        if (!$this->selectedThisElement($method->payment_element)) {
            return false;
        }
        $session = JFactory::getSession();
        $return_context = $session->getId();

        if (!class_exists('VirtueMartModelCurrency'))
            require(VMPATH_ADMIN . DS . 'models' . DS . 'currency.php');

        $new_status = '';

        $usrBT = $order['details']['BT'];
                $address = ((isset($order['details']['BT'])) ? $order['details']['BT'] : $order['details']['ST']);

        if (!class_exists('TableVendors'))
        require(VMPATH_ADMIN . DS . 'table' . DS . 'vendors.php');
        $vendorModel = VmModel::getModel('Vendor');
        $vendorModel->setId(1);
        $vendor = $vendorModel->getVendor();
        $vendorModel->addImages($vendor, 1);
        $this->getPaymentCurrency($method);
        $q = 'SELECT `currency_code_3` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $method->payment_currency . '" ';
        $db = JFactory::getDBO();
        $db->setQuery($q);
        $currency_code_3 = $db->loadResult();

        $paymentCurrency = CurrencyDisplay::getInstance($method->payment_currency);
        $totalInPaymentCurrency = round($paymentCurrency->convertCurrencyTo($method->payment_currency, $order['details']['BT']->order_total, false), 2);
        $cd = CurrencyDisplay::getInstance($cart->pricesCurrency);

        $sadadDetails = $this->_getSadadqaDetails($method);

        if (empty($sadadDetails['sadadqa_id'])) {
            vmInfo(vmText::_('VMPAYMENT_SADADQA_SELLER_ID_NOT_SET'));
            return false;
        }
		
        // Prepare data that should be stored in the database
        $dbValues['order_number'] = $order['details']['BT']->order_number;
        $dbValues['payment_name'] = $this->renderPluginName($method, $order);
        $dbValues['virtuemart_paymentmethod_id'] = $cart->virtuemart_paymentmethod_id;

        $dbValues['payment_currency'] = $method->payment_currency;
        $dbValues['payment_order_total'] = $totalInPaymentCurrency;
        $this->storePSPluginInternalData($dbValues);

        // add html form
       
        $html = '<form action="https://sadadqa.com/webpurchase" method="post" name="gosadad" id="vmPaymentForm" >';
        foreach ($post_variables as $name => $value) {
            $html.= '<input type="hidden" name="' . $name . '" value="' . htmlspecialchars($value) . '" />';
        }
        $html.= '</form><br />';
		$txnDate = date('Y-m-d H:i:s');
		
			$key_id = $sadadDetails['sadadqa_id'];
			$key_secret = trim($sadadDetails['sadadqa_secret']);
			$website = $sadadDetails['sadadqa_website'];
			$chkType = $sadadDetails['sadadqa_checkout_type'];
			$chkLoader = $sadadDetails['sadadqa_hide_loader'];
			$chkType2 = $sadadDetails['sadadqa_checkout_type2'];
			$redirect_url = JURI::root()."index.php?option=com_virtuemart&view=pluginresponse&task=pluginresponsereceived&pm=" . $order['details']['BT']->virtuemart_paymentmethod_id."&o_id={$order['details']['BT']->order_number}";
		
			$sadad_checksum_array = array();
			$sadad__checksum_data = array();
            $i = 0;
            foreach ($cart->products as $key => $product) {
               
				$itemName = substr(strip_tags($product->product_name), 0, 127);
				$sadad_checksum_array['productdetail'][$i]['order_id']    = $order['details']['BT']->order_number;
				$sadad_checksum_array['productdetail'][$i]['itemname']    = html_entity_decode($itemName);
				$sadad_checksum_array['productdetail'][$i]['amount']      = $cart->pricesUnformatted[$key]['salesPrice'];
				$sadad_checksum_array['productdetail'][$i]['totalamount'] = round($product->quantity * $cart->pricesUnformatted[$key]['salesPrice'],2);
				$sadad_checksum_array['productdetail'][$i]['quantity']    = $product->quantity;
				$sadad_checksum_array['productdetail'][$i]['type']        = 'line_item';
				$sadad_checksum_array['productdetail'][$i]['item_meta']   = '';
                $i++;
            }
			
			$sadad_checksum_array['merchant_id']                     = $key_id;
            $sadad_checksum_array['ORDER_ID']                        = $order['details']['BT']->order_number;
            $sadad_checksum_array['WEBSITE']                         = $website;
            $sadad_checksum_array['TXN_AMOUNT']                      = number_format((float)$totalInPaymentCurrency, 2, '.', '');
            //$sadad_checksum_array['shipping_rate']                   = number_format((float)$order['details']['BT']->order_shipment, 2, '.', '');
		    $sadad_checksum_array['VERSION']                         = '1.1';
            $sadad_checksum_array['CUST_ID']                         = $order['details']['BT']->email;
            $sadad_checksum_array['EMAIL']                           = $order['details']['BT']->email;
            $sadad_checksum_array['MOBILE_NO']                       = $address->phone_1;
            $sadad_checksum_array['MODE']                            = 'yes';
            $sadad_checksum_array['SADAD_WEBCHECKOUT_PAGE_LANGUAGE'] = $sadadDetails['sadadqa_lang'];
            $sadad_checksum_array['CALLBACK_URL']                    = $redirect_url;
            $sadad_checksum_array['txnDate']                         = $txnDate;
			
            
            //if webcheckout 2.2, add these fields to checksum
            if ($chkType == 2) {
                $sadad_checksum_array['SADAD_WEBCHECKOUT_HIDE_LOADER'] = $chkLoader;
                $sadad_checksum_array['showdialog']                    = (string) $chkType2;
            }
			$sAry1 = array();
			$sadad_checksum_array1 = array();
			foreach($sadad_checksum_array as $pK => $pV){
				if($pK=='checksumhash') continue;
				if(is_array($pV)){
					$prodSize = sizeof($pV);
					for($i=0;$i<$prodSize;$i++){
						foreach($pV[$i] as $innK => $innV){
							$sAry1[] = "<input type='hidden' name='productdetail[$i][". $innK ."]' value='" . trim($innV) . "'/>";
							$sadad_checksum_array1['productdetail'][$i][$innK]    = trim($innV);
						}
					}
				} else {
					$sAry1[] = "<input type='hidden' name='". $pK ."' id='". $pK ."' value='" . trim($pV) . "'/>";
					$sadad_checksum_array1[$pK]    = trim($pV);
				}
			}
            
            $sadad__checksum_data['postData']  = $sadad_checksum_array1;
            $sadad__checksum_data['secretKey'] = $key_secret;
            $checksum                          = $this->getChecksumFromString(json_encode($sadad__checksum_data), $key_secret . $key_id);
            $sAry1[]                = "<input type='hidden' name='checksumhash' value='" . $checksum . "'/>";
			
			ob_start();
           if ($chkType == 1) {
                $action_url = 'https://sadadqa.com/webpurchase';
                
                echo '<form action="' . $action_url . '" method="post" id="sadad_payment_form" name="gosadad">
                    ' . implode('', $sAry1) . '
                    <script type="text/javascript">
                        document.gosadad.submit();
                    </script>
                    
                </form>';
			   exit;
            } else {
				$action_url = 'https://secure.sadadqa.com/webpurchasepage';
                
                echo '<form action="' . $action_url . '" method="post" id="paymentform" name="paymentform" data-link="' . $action_url . '">
                    ' . implode('', $sAry1) . '
                </form>';
                
?>
               <!--<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>-->
                <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.12.9/umd/popper.min.js" integrity="sha384-ApNbgh9B+Y1QKtv3Rn7W3mgPxhU9K/ScQsAP7hUibX39j7fakFPskvXusvfa0b4Q" crossorigin="anonymous"></script>
                
                <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.min.js" integrity="sha384-JZR6Spejh4U02d8jOt6vLEHfe/JQGiRRSQQxSfFWpi1MquVdAyjUar5+76PVCmYl" crossorigin="anonymous"></script>
                
                <script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-modal/2.2.6/js/bootstrap-modal.min.js"></script>
                
                <script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-modal/2.2.6/js/bootstrap-modalmanager.js"></script>
                
                <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-modal/2.2.6/css/bootstrap-modal.min.css" crossorigin="anonymous">
                
                <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-modal/2.2.6/css/bootstrap-modal-bs3patch.min.css" crossorigin="anonymous">
                
                    <style>
                        .close-btn{
                            height: auto;
                            width: auto;
                            -webkit-appearance: none !important;
                            background: none !important;
                            border: 0px;
                            position: absolute;
                            right: 10px;
                            z-index: 11;
                            cursor: pointer;
                            outline: 0px !important;
                            box-shadow: none;
                            top: 15px;
                        }
                        .close, .close:hover{
                            color: #000;
                            font-size:30px;
                        }
                        .modal-body{
                            padding: 0px;
                            border-radius: 15px;
                        }
                        #onlyiframe{
                         width:100% !important;
                         height:100vh !important;
                         overflow: hidden !important;
                         border:0;
                        
                         top: 0;
                         left: 0;
                         bottom: 0;
                         right: 0;
                              
                        }
                        #includeiframe{
                            height:100vh !important;
                         overflow: hidden !important;
                        border:0;
						width:100%;
                        }
                        .modal-backdrop {
                           background-color: #000 !important;
                        }
						#exampleModal .modal-content{
							background: #fff !important;
						}
                    </style>
                    <!-- Modal -->
                    <div id="container_div_sadad">
                    <div class="modal fade not_hide_sadad" id="exampleModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true" data-backdrop='static'>
                        <div class="modal-dialog" role="document">
                            <div class="modal-content">
                                <button type="button" class="close-btn" onClick="closemodal();" aria-label="Close">
                                    <span class="close">&times;</span>
                                </button>
                                <div class="modal-body">
                                    <iframe name="includeiframe" id="includeiframe" frameborder="0" scrolling="no"></iframe>
                                </div>
                            </div>
                        </div>
                    </div>
                    <iframe name="onlyiframe" id="onlyiframe" border="0" class="not_hide_sadad" frameborder="0" scrolling="no"></iframe>
                    </div>
                    
                    <script>
                        function closemodal()
                        {
							window.location.href = '<?php echo $callBackUrl; ?>index.php?controller=order&step=1';
                            
                        }
                        jQuery(document).ready(function($){
                        
                                if ($('#showdialog').val() == 1) {
                                
                                      $('#exampleModal').modal('show');
                                      $('#paymentform').attr('target', 'includeiframe').submit();
                                      $('#onlyiframe').hide();
                                    
                                } else {
                                     $('#exampleModal').modal('hide');
                                     $('#paymentform').attr('target', 'onlyiframe').submit();
                                    
                                }
                             $('iframe').load(function() {
                                    $(this).height( $(this).contents().find("body").height() );
                                    if(this.contentWindow.location=='<?php
                echo $redirect_url;
?>'){
									
									$(this).hide();
									window.location.href = '';
                                        
                                    }
                                });    
                        });
                    </script>

                <?php
			}
			$msgDataa = ob_get_contents();
			ob_end_clean();
		
		


        //vmJsApi::addJScript('vm.paymentFormAutoSubmit', '');

        return $this->processConfirmedOrderPaymentResponse(2, $cart, $order, $msgDataa, $dbValues['payment_name'], $new_status);
    }

    function plgVmgetPaymentCurrency($virtuemart_paymentmethod_id, &$paymentCurrencyId) {

        if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id))) {
            return null; // Another method was selected, do nothing
        }
        if (!$this->selectedThisElement($method->payment_element)) {
            return false;
        }
        $this->getPaymentCurrency($method);
        $paymentCurrencyId = $method->payment_currency;
    }

    function plgVmOnPaymentResponseReceived(&$html) {

        $virtuemart_paymentmethod_id = vRequest::getInt('pm', 0);
        $order_number = vRequest::getVar('on', 0);  //?

        if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id))) {
            return null; // Another method was selected, do nothing
        }
        if (!$this->selectedThisElement($method->payment_element)) {
            return false;
        }
        if (!class_exists('VirtueMartCart'))
        require(JPATH_VM_SITE . DS . 'helpers' . DS . 'cart.php');
        if (!class_exists('shopFunctionsF'))
        require(JPATH_VM_SITE . DS . 'helpers' . DS . 'shopfunctionsf.php');
		// setup response html
        vmLanguage::loadJLang('com_virtuemart');
        $modelOrder = VmModel::getModel('orders');
        
        $sadadData = vRequest::getRequest();
        $payment_name = $this->renderPluginName($method);
        
		$sadadDetails = $this->_getSadadqaDetails($method);
		
		$merhcntId = $sadadDetails['sadadqa_id'];
			$key_secret = trim($sadadDetails['sadadqa_secret']);
		
        if (!empty($sadadData)) {
            vmdebug('plgVmOnPaymentResponseReceived', $sadadData);
            $order_number = $sadadData['ORDERID'];
            $virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($order_number);

            if ($virtuemart_order_id) {
                $order = $modelOrder->getOrder($virtuemart_order_id);
                $customer_total = (number_format((float)$order['details']['BT']->order_total, 2, '.', ''));
                $payment_name = $this->renderPluginName($method);

                $order['customer_notified']=1;
                //$order['order_status'] = 'as';
                $order['comments'] = vmText::sprintf('VMPAYMENT_SADADQA_PAYMENT_STATUS_CONFIRMED', $order_number);
				
				$sadadData1 = $sadadData;
				
				$checksum_response = $sadadData1['checksumhash'];
				unset($sadadData1['checksumhash']);
				unset($sadadData1['option']);
				unset($sadadData1['view']);
				unset($sadadData1['task']);
				unset($sadadData1['pm']);
				unset($sadadData1['o_id']);
				unset($sadadData1['o_id']);
				unset($sadadData1['Itemid']);
				$sadad_id                   = $merhcntId;
				$sadad_secrete_key          = trim($key_secret);
				$data_repsonse              = array();
				$data_repsonse['postData']  = $sadadData1;
				$data_repsonse['secretKey'] = $sadad_secrete_key;
				$key12                        = $sadad_secrete_key . $sadad_id;
				
				
				if ($this->verifychecksum_eFromStr(json_encode($data_repsonse), $key12, $checksum_response) === "TRUE" && $sadadData['RESPCODE'] == 1 && $sadadData['TXNAMOUNT'] >= $customer_total && $sadadData['STATUS'] == 'TXN_SUCCESS') {
					$order['order_status'] = $method->status_success;
				}
       		 	else {
            		$order['order_status'] = $method->status_pending;
        		}
				
                // send the email ONLY if payment has been accepted

                $nb_history = count($order['history']);
                if ($order['history'][$nb_history - 1]->order_status_code != $order['order_status']) {
                    $this->_storeSadadqaInternalData($method, $sadadData, $virtuemart_order_id);
                    $this->logInfo('plgVmOnPaymentResponseReceived, sentOrderConfirmedEmail ' . $order_number, 'message');
                    $order['virtuemart_order_id'] = $virtuemart_order_id;
                    $order['comments'] = vmText::sprintf('VMPAYMENT_SADADQA_EMAIL_SENT');
                    $modelOrder->updateStatusForOneOrder($virtuemart_order_id, $order, true);
                }

               
                $html = $this->_getPaymentResponseHtml($sadadData, $payment_name);
                $link=	JRoute::_("index.php?option=com_virtuemart&view=orders&layout=details&order_number=".$order['details']['BT']->order_number."&order_pass=".$order['details']['BT']->order_pass, false) ;
        		$html .='<br />
        		<a class="vm-button-correct" href="'.$link.'">'.vmText::_('COM_VIRTUEMART_ORDER_VIEW_ORDER').'</a>';
            } else {
                vmError('Sadad data received, but no order number');
                return;
            }
        } else {
            $virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($order_number);
        }

        $cart = VirtueMartCart::getCart();
        $cart->emptyCart();
        return true;
    }

    function plgVmOnUserPaymentCancel() {

        if (!class_exists('VirtueMartModelOrders'))
        require( JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php' );

        $order_number = vRequest::getVar('on');
        if (!$order_number)
        return false;
        $db = JFactory::getDBO();
        $query = 'SELECT ' . $this->_tablename . '.`virtuemart_order_id` FROM ' . $this->_tablename . " WHERE  `order_number`= '" . $order_number . "'";

        $db->setQuery($query);
        $virtuemart_order_id = $db->loadResult();

        if (!$virtuemart_order_id) {
            return null;
        }
        $this->handlePaymentUserCancel($virtuemart_order_id);

        return true;
    }

    function _storeSadadqaInternalData($method, $sadadData, $virtuemart_order_id) {
        
		$response_fields['virtuemart_paymentmethod_id'] = $method->virtuemart_paymentmethod_id; 
		$response_fields['payment_currency'] = 'QAR';
		$response_fields['sadadqa_transaction_id'] = $sadadData['transaction_number'];
        $response_fields['payment_name'] = $this->renderPluginName($method);
        $response_fields['order_number'] = $sadadData['transaction_number'];
		$response_fields['payment_order_total'] = $sadadData['TXNAMOUNT'];
        $response_fields['virtuemart_order_id'] = $virtuemart_order_id;
        $this->storePSPluginInternalData($response_fields, 'virtuemart_order_id', true);
    }

    function _getTablepkeyValue($virtuemart_order_id) {
        $db = JFactory::getDBO();
        $q = 'SELECT ' . $this->_tablepkey . ' FROM `' . $this->_tablename . '` '
        . 'WHERE `virtuemart_order_id` = ' . $virtuemart_order_id;
        $db->setQuery($q);

        if (!($pkey = $db->loadResult())) {
            JError::raiseWarning(500, $db->getErrorMsg());
            return '';
        }
        return $pkey;
    }


    function plgVmOnShowOrderBEPayment($virtuemart_order_id, $payment_method_id) {

        if (!$this->selectedThisByMethodId($payment_method_id)) {
            return null; // Another method was selected, do nothing
        }

        if (!($paymentTable = $this->getDataByOrderId ($virtuemart_order_id))) {
			return NULL;
		}
		vmLanguage::loadJLang('com_virtuemart');
		$html = '<table class="adminlist table">' . "\n";
		$html .= $this->getHtmlHeaderBE ();
		$html .= $this->getHtmlRowBE ('COM_VIRTUEMART_PAYMENT_NAME', $paymentTable->payment_name);
		$html .= $this->getHtmlRowBE ('VMPAYMENT_SADADQA_ORDER_NUMBER', $paymentTable->sadadqa_transaction_id);
		$html .= '</table>' . "\n";
		return $html;

        return $html;
    }

    function _getPaymentResponseHtml($sadadTable, $payment_name) {

        $html = '<table>' . "\n";
        if (!empty($sadadTable)) {
            $html .= $this->getHtmlRow('VMPAYMENT_SADADQA_ORDER_NUMBER', $sadadTable['transaction_number']);
            $html .= $this->getHtmlRow('VMPAYMENT_SADADQA_AMOUNT', $sadadTable['TXNAMOUNT'] . " QAR");
        }
        $html .= '</table>' . "\n";

        return $html;
    }

    function getCosts(VirtueMartCart $cart, $method, $cart_prices) {
        if (preg_match('/%$/', $method->cost_percent_total)) {
            $cost_percent_total = substr($method->cost_percent_total, 0, -1);
        } else {
            $cost_percent_total = $method->cost_percent_total;
        }
        return ($method->cost_per_transaction + ($cart_prices['salesPrice'] * $cost_percent_total * 0.01));
    }


    protected function checkConditions($cart, $method, $cart_prices) {

		return parent::checkConditions($cart, $method, $cart_prices);

    }

    function plgVmOnStoreInstallPaymentPluginTable($jplugin_id) {

        return $this->onStoreInstallPluginTable($jplugin_id);
    }

    public function plgVmOnSelectCheckPayment(VirtueMartCart $cart) {
        return $this->OnSelectCheck($cart);
    }

    public function plgVmDisplayListFEPayment(VirtueMartCart $cart, $selected = 0, &$htmlIn) {
        return $this->displayListFE($cart, $selected, $htmlIn);
    }

    public function plgVmonSelectedCalculatePricePayment(VirtueMartCart $cart, array &$cart_prices, &$cart_prices_name) {
        return $this->onSelectedCalculatePrice($cart, $cart_prices, $cart_prices_name);
    }

    function plgVmOnCheckAutomaticSelectedPayment(VirtueMartCart $cart, array $cart_prices = array()) {
        return $this->onCheckAutomaticSelected($cart, $cart_prices);
    }

    public function plgVmOnShowOrderFEPayment($virtuemart_order_id, $virtuemart_paymentmethod_id, &$payment_name) {
        $this->onShowOrderFE($virtuemart_order_id, $virtuemart_paymentmethod_id, $payment_name);
    }

    function plgVmonShowOrderPrintPayment($order_number, $method_id) {
        return $this->onShowOrderPrint($order_number, $method_id);
    }

    function plgVmDeclarePluginParamsPayment($name, $id, &$data) {
        return $this->declarePluginParams('payment', $name, $id, $data);
    }

    function plgVmDeclarePluginParamsPaymentVM3( &$data) {
		return $this->declarePluginParams('payment', $data);
	}

    function plgVmSetOnTablePluginParamsPayment($name, $id, &$table) {
        return $this->setOnTablePluginParams($name, $id, $table);
    }
	
	private function getChecksumFromString($str, $key) {
	
		
	
		$salt = $this->generateSalt_e(4);
	
		$finalString = $str . "|" . $salt;
	
		$hash = hash("sha256", $finalString);
	
		$hashString = $hash . $salt;
	
		$checksum = $this->encrypt_e($hashString, $key);
	
		return $checksum;
	
	}
	
	
	
	private function generateSalt_e($length) {
	
		$random = "";
	
		srand((double) microtime() * 1000000);
	
	
	
		$data = "AbcDE123IJKLMN67QRSTUVWXYZ";
	
		$data .= "aBCdefghijklmn123opq45rs67tuv89wxyz";
	
		$data .= "0FGH45OP89";
	
		for ($i = 0; $i < $length; $i++) {
	
			$random .= substr($data, (rand() % (strlen($data))), 1);
	
		}
	
		return $random;
	
	}



	private function encrypt_e($input, $ky) {
	
	$ky = html_entity_decode($ky);
	
	$iv = "@@@@&&&&####$$$$";
	
	$data = openssl_encrypt($input, "AES-128-CBC", $ky, 0, $iv);
	
	return $data;
	
	}
	
	private function verifychecksum_eFromStr($str, $key, $checksumvalue) {
	
	$sadad_hash = $this->decrypt_e($checksumvalue, $key);
	
	$salt = substr($sadad_hash, -4);
	
	
	
	$finalString = $str . "|" . $salt;
	
	
	
	$website_hash = hash("sha256", $finalString);
	
	$website_hash .= $salt;
	
	
	
	$validFlag = "FALSE";
	
	if ($website_hash == $sadad_hash) {
	
	$validFlag = "TRUE";
	
	} else {
	
	$validFlag = "FALSE";
	
	}
	
	return $validFlag;
	
	}
	
	
	
	private function decrypt_e($crypt, $ky) {
	
	$ky = html_entity_decode($ky);
	
	$iv = "@@@@&&&&####$$$$";
	
	$data = openssl_decrypt($crypt, "AES-128-CBC", $ky, 0, $iv);
	
	return $data;
	
	}

}

// No closing tag
